import requests
import json

# 初始化获得token
# 以下内容需要修改
client_id = '***********'
tenant_id = '*******************'
client_secret = '********************'
# 注意这是a1p的sku_id，要是a1需要自己修改为a1的sku_id，可不改
sku_id = 'e82ae690-a2d5-4d76-8d30-7c6e01e6022e'
url = 'https://login.microsoftonline.com/' + tenant_id + '/oauth2/v2.0/token'
scope = 'https://graph.microsoft.com/.default'
data = {
    'grant_type': 'client_credentials',
    'client_id': client_id,
    'client_secret': client_secret,
    'scope': scope
}
r = requests.post(url, data)
token = r.json()['access_token']
header = {
    'Authorization': 'Bearer ' + token,
    'Content-Type': 'application/json'
}


# 传入参数可以选择id或者邮箱
def get_user(user_email_id):
    url = 'https://graph.microsoft.com/v1.0/users/' + user_email_id
    r = requests.get(url, headers=header)
    # print(r.json())
    return r.json()


# 修改为你要自己设置为管理员的子账号邮箱
user_info = get_user("test@*********.onmicrosoft.com")
user_id = user_info['id']
data = {
    "@odata.id": f"https://graph.microsoft.com/v1.0/directoryObjects/{user_id}"
}
# roleTemplateId=62e90394-69f5-4237-9190-012177145e10为全局管理员id
# 详细信息如下
# {
#        "id": "62e90394-69f5-4237-9190-012177145e10",
#        "deletedDateTime": "None",
#        "description": "Can manage all aspects of users and groups, including resetting passwords for limited admins.",
#        "displayName": "Global Administrator",
#        "roleTemplateId": "62e90394-69f5-4237-9190-012177145e10"
#      },
r = requests.post("https://graph.microsoft.com/v1.0/directoryRoles/roleTemplateId=62e90394-69f5-4237-9190-012177145e10/members/$ref", headers=header, data=json.dumps(data))
# 成功返回204,其他则代表操作失败
print(r.status_code)
# 显示错误信息
print(r.text)






